Index: frontends/php/api/classes/class.citem.php
===================================================================
--- frontends/php/api/classes/class.citem.php	(revision 38884)
+++ frontends/php/api/classes/class.citem.php	(working copy)
@@ -289,10 +289,10 @@
 			}
 
 			if(isset($options['filter']['hostid']))
-				$sql_parts['where']['hostid'] = 'i.hostid='.$options['filter']['hostid'];
+				$sql_parts['where']['hostid'] = 'i.hostid='.zbx_dbstr($options['filter']['hostid']);
 
 			if(isset($options['filter']['itemid']))
-				$sql_parts['where']['itemid'] = 'i.itemid='.$options['filter']['itemid'];
+				$sql_parts['where']['itemid'] = 'i.itemid='.zbx_dbstr($options['filter']['itemid']);
 				
 			if(isset($options['filter']['description']))
 				$sql_parts['where']['description'] = 'i.description='.zbx_dbstr($options['filter']['description']);
@@ -301,7 +301,7 @@
 				$sql_parts['where']['key_'] = 'i.key_='.zbx_dbstr($options['filter']['key_']);
 
 			if(isset($options['filter']['type']))
-				$sql_parts['where'][] = 'i.type='.$options['filter']['type'];
+				$sql_parts['where'][] = 'i.type='.zbx_dbstr($options['filter']['type']);
 
 			if(isset($options['filter']['snmp_community']))
 				$sql_parts['where'][] = 'i.snmp_community='.zbx_dbstr($options['filter']['snmp_community']);
@@ -310,7 +310,7 @@
 				$sql_parts['where'][] = 'i.snmp_oid='.zbx_dbstr($options['filter']['snmp_oid']);
 
 			if(isset($options['filter']['snmp_port']))
-				$sql_parts['where'][] = 'i.snmp_port='.$options['filter']['snmp_port'];
+				$sql_parts['where'][] = 'i.snmp_port='.zbx_dbstr($options['filter']['snmp_port']);
 
 			if(isset($options['filter']['value_type'])){
 				zbx_value2array($options['filter']['value_type']);
@@ -319,19 +319,19 @@
 			}
 
 			if(isset($options['filter']['data_type']))
-				$sql_parts['where'][] = 'i.data_type='.$options['filter']['data_type'];
+				$sql_parts['where'][] = 'i.data_type='.zbx_dbstr($options['filter']['data_type']);
 
 			if(isset($options['filter']['delay']))
-				$sql_parts['where'][] = 'i.delay='.$options['filter']['delay'];
+				$sql_parts['where'][] = 'i.delay='.zbx_dbstr($options['filter']['delay']);
 
 			if(isset($options['filter']['trends']))
-				$sql_parts['where'][] = 'i.trends='.$options['filter']['trends'];
+				$sql_parts['where'][] = 'i.trends='.zbx_dbstr($options['filter']['trends']);
 
 			if(isset($options['filter']['history']))
-				$sql_parts['where'][] = 'i.history='.$options['filter']['history'];
+				$sql_parts['where'][] = 'i.history='.zbx_dbstr($options['filter']['history']);
 
 			if(isset($options['filter']['status']))
-				$sql_parts['where'][] = 'i.status='.$options['filter']['status'];
+				$sql_parts['where'][] = 'i.status='.zbx_dbstr($options['filter']['status']);
 		}
 
 // group
Index: frontends/php/api/classes/class.cusermacro.php
===================================================================
--- frontends/php/api/classes/class.cusermacro.php	(revision 38884)
+++ frontends/php/api/classes/class.cusermacro.php	(working copy)
@@ -491,7 +491,7 @@
 		foreach($macros as $hostid => $mac_list){
 			$sql = 'SELECT hostmacroid '.
 					' FROM hostmacro '.
-					' WHERE hostid='.$hostid.
+					' WHERE hostid='.zbx_dbstr($hostid).
 					' AND '.DBcondition('macro', $mac_list, false, true);
 			$res = DBselect($sql);
 			while($macro = DBfetch($res)){
@@ -535,7 +535,7 @@
 				$hostmacroid = get_dbid('hostmacro', 'hostmacroid');
 
 				$sql = 'INSERT INTO hostmacro (hostmacroid, hostid, macro, value)
-					VALUES('.$hostmacroid.', '.$macro['hostid'].', '.zbx_dbstr($macro['macro']).', '.zbx_dbstr($macro['value']).')';
+					VALUES('.$hostmacroid.', '.zbx_dbstr($macro['hostid']).', '.zbx_dbstr($macro['macro']).', '.zbx_dbstr($macro['value']).')';
 				$result = DBExecute($sql);
 
 				if(!$result) break;
@@ -638,7 +638,7 @@
 
 			$sql = 'UPDATE hostmacro '.
 					' SET value='.zbx_dbstr($macro['value']).
-					' WHERE hostid='.$macro['hostid'].
+					' WHERE hostid='.zbx_dbstr($macro['hostid']).
 						' AND macro='.zbx_dbstr($macro['macro']);
 			$result = DBExecute($sql);
 
@@ -835,7 +835,7 @@
 
 		$sql = 'SELECT globalmacroid '.
 				' FROM globalmacro '.
-				' WHERE globalmacroid='.$macro_data['globalmacroid'];
+				' WHERE globalmacroid='.zbx_dbstr($macro_data['globalmacroid']);
 		$res = DBselect($sql);
 		while($macro = DBfetch($res)){
 			$globalmacroids[$macro[globalmacroid]] = $macro[globalmacroid];
@@ -867,7 +867,7 @@
 		$sql = 'SELECT hostmacroid '.
 				' FROM hostmacro '.
 				' WHERE macro='.zbx_dbstr($macro_data['macro']).
-					' AND hostid='.$macro_data['hostid'].
+					' AND hostid='.zbx_dbstr($macro_data['hostid']).
 					' AND '.DBin_node('hostmacroid', false);
 		$res = DBselect($sql);
 		if($macroid = DBfetch($res))
@@ -928,7 +928,7 @@
 								if(($link['macro'] == $macro['macro']) && ($link['hostid'] == $hostid)) continue 2;
 							}
 
-							$values = array(get_dbid('hostmacro', 'hostmacroid'), $hostid, zbx_dbstr($macro['macro']),
+							$values = array(get_dbid('hostmacro', 'hostmacroid'), zbx_dbstr($hostid), zbx_dbstr($macro['macro']),
 								zbx_dbstr($macro['value']));
 							$sql = 'INSERT INTO hostmacro (hostmacroid, hostid, macro, value) VALUES ('. implode(', ', $values) .')';
 
Index: frontends/php/api/classes/class.cgraph.php
===================================================================
--- frontends/php/api/classes/class.cgraph.php	(revision 38884)
+++ frontends/php/api/classes/class.cgraph.php	(working copy)
@@ -204,7 +204,7 @@
 
 // type
 		if(!is_null($options['type'] )){
-			$sql_parts['where'][] = 'g.type='.$options['type'];
+			$sql_parts['where'][] = 'g.type='.zbx_dbstr($options['type']);
 		}
 
 // templated
@@ -267,7 +267,7 @@
 				$sql_parts['where']['name'] = 'g.name='.zbx_dbstr($options['filter']['name']);
 
 			if(isset($options['filter']['templateid']))
-				$sql_parts['where']['templateid'] = 'g.templateid='.$options['filter']['templateid'];
+				$sql_parts['where']['templateid'] = 'g.templateid='.zbx_dbstr($options['filter']['templateid']);
 
 			if(isset($options['filter']['host']) || isset($options['filter']['hostid'])){
 				$sql_parts['from']['gi'] = 'graphs_items gi';
@@ -282,7 +282,7 @@
 				}
 
 				if(isset($options['filter']['hostid']))
-					$sql_parts['where']['hostid'] = 'i.hostid='.$options['filter']['hostid'];
+					$sql_parts['where']['hostid'] = 'i.hostid='.zbx_dbstr($options['filter']['hostid']);
 			}
 		}
 
@@ -751,23 +751,23 @@
 			'graphid' => $graphid,
 			'name' => zbx_dbstr($graph['name'])
 		);
-		if(isset($graph['width'])) $values['width'] = $graph['width'];
-		if(isset($graph['height'])) $values['height'] = $graph['height'];
-		if(isset($graph['ymin_type'])) $values['ymin_type'] = $graph['ymin_type'];
-		if(isset($graph['ymax_type'])) $values['ymax_type'] = $graph['ymax_type'];
-		if(isset($graph['yaxismin'])) $values['yaxismin'] = $graph['yaxismin'];
-		if(isset($graph['yaxismax'])) $values['yaxismax'] = $graph['yaxismax'];
-		if(isset($graph['ymin_itemid'])) $values['ymin_itemid'] = $graph['ymin_itemid'];
-		if(isset($graph['ymax_itemid'])) $values['ymax_itemid'] = $graph['ymax_itemid'];
-		if(isset($graph['show_work_period'])) $values['show_work_period'] = $graph['show_work_period'];
-		if(isset($graph['show_triggers'])) $values['show_triggers'] = $graph['show_triggers'];
-		if(isset($graph['graphtype'])) $values['graphtype'] = $graph['graphtype'];
-		if(isset($graph['show_legend'])) $values['show_legend'] = $graph['show_legend'];
-		if(isset($graph['show_3d'])) $values['show_3d'] = $graph['show_3d'];
-		if(isset($graph['percent_left'])) $values['percent_left'] = $graph['percent_left'];
-		if(isset($graph['percent_right'])) $values['percent_right'] = $graph['percent_right'];
-		if(isset($graph['templateid'])) $values['templateid'] = $graph['templateid'];
-		
+		if(isset($graph['width'])) $values['width'] = zbx_dbstr($graph['width']);
+		if(isset($graph['height'])) $values['height'] = zbx_dbstr($graph['height']);
+		if(isset($graph['ymin_type'])) $values['ymin_type'] = zbx_dbstr($graph['ymin_type']);
+		if(isset($graph['ymax_type'])) $values['ymax_type'] = zbx_dbstr($graph['ymax_type']);
+		if(isset($graph['yaxismin'])) $values['yaxismin'] = zbx_dbstr($graph['yaxismin']);
+		if(isset($graph['yaxismax'])) $values['yaxismax'] = zbx_dbstr($graph['yaxismax']);
+		if(isset($graph['ymin_itemid'])) $values['ymin_itemid'] = zbx_dbstr($graph['ymin_itemid']);
+		if(isset($graph['ymax_itemid'])) $values['ymax_itemid'] = zbx_dbstr($graph['ymax_itemid']);
+		if(isset($graph['show_work_period'])) $values['show_work_period'] = zbx_dbstr($graph['show_work_period']);
+		if(isset($graph['show_triggers'])) $values['show_triggers'] = zbx_dbstr($graph['show_triggers']);
+		if(isset($graph['graphtype'])) $values['graphtype'] = zbx_dbstr($graph['graphtype']);
+		if(isset($graph['show_legend'])) $values['show_legend'] = zbx_dbstr($graph['show_legend']);
+		if(isset($graph['show_3d'])) $values['show_3d'] = zbx_dbstr($graph['show_3d']);
+		if(isset($graph['percent_left'])) $values['percent_left'] = zbx_dbstr($graph['percent_left']);
+		if(isset($graph['percent_right'])) $values['percent_right'] = zbx_dbstr($graph['percent_right']);
+		if(isset($graph['templateid'])) $values['templateid'] = zbx_dbstr($graph['templateid']);
+
 		$sql = 'INSERT INTO graphs ('.implode(', ', array_keys($values)).') VALUES ('.implode(', ', $values).')';
 		DBexecute($sql) or self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');			
 	
@@ -776,14 +776,14 @@
 				'gitemid' => get_dbid('graphs_items', 'gitemid'),
 				'graphid' => $graphid,
 			);
-			if(isset($gitem['itemid'])) $values['itemid'] = $gitem['itemid'];
+			if(isset($gitem['itemid'])) $values['itemid'] = zbx_dbstr($gitem['itemid']);
 			if(isset($gitem['color'])) $values['color'] = zbx_dbstr($gitem['color']);
-			if(isset($gitem['drawtype'])) $values['drawtype'] = $gitem['drawtype'];
-			if(isset($gitem['sortorder'])) $values['sortorder'] = $gitem['sortorder'];
-			if(isset($gitem['yaxisside'])) $values['yaxisside'] = $gitem['yaxisside'];
-			if(isset($gitem['calc_fnc'])) $values['calc_fnc'] = $gitem['calc_fnc'];
-			if(isset($gitem['type'])) $values['type'] = $gitem['type'];
-			if(isset($gitem['periods_cnt'])) $values['periods_cnt'] = $gitem['periods_cnt'];
+			if(isset($gitem['drawtype'])) $values['drawtype'] = zbx_dbstr($gitem['drawtype']);
+			if(isset($gitem['sortorder'])) $values['sortorder'] = zbx_dbstr($gitem['sortorder']);
+			if(isset($gitem['yaxisside'])) $values['yaxisside'] = zbx_dbstr($gitem['yaxisside']);
+			if(isset($gitem['calc_fnc'])) $values['calc_fnc'] = zbx_dbstr($gitem['calc_fnc']);
+			if(isset($gitem['type'])) $values['type'] = zbx_dbstr($gitem['type']);
+			if(isset($gitem['periods_cnt'])) $values['periods_cnt'] = zbx_dbstr($gitem['periods_cnt']);
 			
 			$sql = 'INSERT INTO graphs_items ('.implode(', ', array_keys($values)).') VALUES ('.implode(', ', $values).')';
 			DBexecute($sql) or self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');
@@ -794,7 +794,7 @@
 	
 	protected static function updateReal($graph){
 		$values = array(
-			'name' => zbx_dbstr($graph['name'])
+			'name' => $graph['name']
 		);
 		if(isset($graph['width'])) $values['width'] = $graph['width'];
 		if(isset($graph['height'])) $values['height'] = $graph['height'];
@@ -815,29 +815,29 @@
 		
 		$q = '';
 		foreach($values as $field => $value){
-			$q .= $field.'='.$value.', ';
+			$q .= $field.'='.zbx_dbstr($value).', ';
 		}
 		$q = rtrim($q, ', ');
-		$sql = 'UPDATE graphs SET '.$q.' WHERE graphid='.$graph['graphid'];
+		$sql = 'UPDATE graphs SET '.$q.' WHERE graphid='.zbx_dbstr($graph['graphid']);
 		DBexecute($sql) or self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');			
 	
 	
-		DBexecute('DELETE FROM graphs_items WHERE graphid='.$graph['graphid'])
+		DBexecute('DELETE FROM graphs_items WHERE graphid='.zbx_dbstr($graph['graphid']))
 			or self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');
 		
 		foreach($graph['gitems'] as $gitem){
 			$values = array(
 				'gitemid' => get_dbid('graphs_items', 'gitemid'),
-				'graphid' => $graph['graphid']
+				'graphid' => zbx_dbstr($graph['graphid'])
 			);
-			if(isset($gitem['itemid'])) $values['itemid'] = $gitem['itemid'];
+			if(isset($gitem['itemid'])) $values['itemid'] = zbx_dbstr($gitem['itemid']);
 			if(isset($gitem['color'])) $values['color'] = zbx_dbstr($gitem['color']);
-			if(isset($gitem['drawtype'])) $values['drawtype'] = $gitem['drawtype'];
-			if(isset($gitem['sortorder'])) $values['sortorder'] = $gitem['sortorder'];
-			if(isset($gitem['yaxisside'])) $values['yaxisside'] = $gitem['yaxisside'];
-			if(isset($gitem['calc_fnc'])) $values['calc_fnc'] = $gitem['calc_fnc'];
-			if(isset($gitem['type'])) $values['type'] = $gitem['type'];
-			if(isset($gitem['periods_cnt'])) $values['periods_cnt'] = $gitem['periods_cnt'];
+			if(isset($gitem['drawtype'])) $values['drawtype'] = zbx_dbstr($gitem['drawtype']);
+			if(isset($gitem['sortorder'])) $values['sortorder'] = zbx_dbstr($gitem['sortorder']);
+			if(isset($gitem['yaxisside'])) $values['yaxisside'] = zbx_dbstr($gitem['yaxisside']);
+			if(isset($gitem['calc_fnc'])) $values['calc_fnc'] = zbx_dbstr($gitem['calc_fnc']);
+			if(isset($gitem['type'])) $values['type'] = zbx_dbstr($gitem['type']);
+			if(isset($gitem['periods_cnt'])) $values['periods_cnt'] = zbx_dbstr($gitem['periods_cnt']);
 			
 			$sql = 'INSERT INTO graphs_items ('.implode(', ', array_keys($values)).') VALUES ('.implode(', ', $values).')';
 			DBexecute($sql) or self::exception(ZBX_API_ERROR_PARAMETERS, 'DBerror');
@@ -1127,7 +1127,7 @@
 		if($host["status"] == HOST_STATUS_TEMPLATE ){
 			$sql = 'SELECT DISTINCT count(i.hostid) as count
 					FROM items i
-					WHERE i.hostid<>'.$host['hostid'].
+					WHERE i.hostid<>'.zbx_dbstr($host['hostid']).
 						' AND '.DBcondition('i.itemid', $itemids);
 
 			$host_count = DBfetch(DBselect($sql));
@@ -1219,7 +1219,7 @@
 
 		$sql = 'DELETE
 				FROM graphs_items
-				WHERE graphid='.$graphid.
+				WHERE graphid='.zbx_dbstr($graphid).
 					' AND '.DBcondition('itemid', $gitems);
 		$result = DBselect($sql);
 
Index: frontends/php/api/classes/class.capplication.php
===================================================================
--- frontends/php/api/classes/class.capplication.php	(revision 38884)
+++ frontends/php/api/classes/class.capplication.php	(working copy)
@@ -251,7 +251,7 @@
 				$sql_parts['where']['name'] = 'a.name='.zbx_dbstr($options['filter']['name']);
 
 			if(isset($options['filter']['hostid']))
-				$sql_parts['where']['hostid'] = 'a.hostid='.$options['filter']['hostid'];
+				$sql_parts['where']['hostid'] = 'a.hostid='.zbx_dbstr($options['filter']['hostid']);
 		}
 
 // order
@@ -676,7 +676,7 @@
 				if(isset($linked[$applicationid]) && isset($linked[$applicationid][$itemid])) continue;
 
 				$itemappid = get_dbid('items_applications', 'itemappid');
-				$result = DBexecute("INSERT INTO items_applications (itemappid, itemid, applicationid) VALUES ($itemappid, $itemid, $applicationid)");
+				$result = DBexecute("INSERT INTO items_applications (itemappid, itemid, applicationid) VALUES ($itemappid, ".zbx_dbstr($itemid).", ".zbx_dbstr($applicationid).")");
 				if(!$result){
 					break 2;
 				}
@@ -686,13 +686,13 @@
 		if($result){
 			$child_applications = array();
 			foreach($itemids as $itemid){
-				$db_childs = DBselect('SELECT itemid, hostid FROM items WHERE templateid='.$itemid);
+				$db_childs = DBselect('SELECT itemid, hostid FROM items WHERE templateid='.zbx_dbstr($itemid));
 
 				if($child = DBfetch($db_childs)){
 					$sql = 'SELECT a1.applicationid '.
 							' FROM applications a1, applications a2 '.
 							' WHERE a1.name=a2.name '.
-								' AND a1.hostid='.$child['hostid'].
+								' AND a1.hostid='.zbx_dbstr($child['hostid']).
 								' AND '.DBcondition('a2.applicationid', $applicationids);
 					$db_apps = DBselect($sql);
 					while($app = DBfetch($db_apps)){
Index: frontends/php/api/classes/class.ctrigger.php
===================================================================
--- frontends/php/api/classes/class.ctrigger.php	(revision 38884)
+++ frontends/php/api/classes/class.ctrigger.php	(working copy)
@@ -252,7 +252,7 @@
 
 // status
 		if(!is_null($options['status'])){
-			$sql_parts['where'][] = 't.status='.$options['status'];
+			$sql_parts['where'][] = 't.status='.zbx_dbstr($options['status']);
 		}
 
 // monitored
@@ -432,7 +432,7 @@
 
 // min_severity
 		if(!is_null($options['min_severity'])){
-			$sql_parts['where'][] = 't.priority>='.$options['min_severity'];
+			$sql_parts['where'][] = 't.priority>='.zbx_dbstr($options['min_severity']);
 		}
 
 // countOutput
Index: frontends/php/api/classes/class.cscript.php
===================================================================
--- frontends/php/api/classes/class.cscript.php	(revision 38884)
+++ frontends/php/api/classes/class.cscript.php	(working copy)
@@ -342,7 +342,7 @@
 		$sql = 'SELECT scriptid '.
 				' FROM scripts '.
 				' WHERE '.DBin_node('scriptid').
-					' AND name='.$script['name'];
+					' AND name='.zbx_dbstr($script['name']);
 		$res = DBselect($sql);
 		while($script = DBfetch($res)){
 			$scriptids[$script['scriptid']] = $script['scriptid'];
Index: frontends/php/api/classes/class.calert.php
===================================================================
--- frontends/php/api/classes/class.calert.php	(revision 38884)
+++ frontends/php/api/classes/class.calert.php	(working copy)
@@ -266,27 +266,27 @@
 
 // status
 		if(!is_null($options['status'])){
-			$sql_parts['where'][] = 'a.status='.$options['status'];
+			$sql_parts['where'][] = 'a.status='.zbx_dbstr($options['status']);
 		}
 
 // sendto
 		if(!is_null($options['sendto'])){
-			$sql_parts['where'][] = 'a.sendto='.$options['sendto'];
+			$sql_parts['where'][] = 'a.sendto='.zbx_dbstr($options['sendto']);
 		}
 
 // alerttype
 		if(!is_null($options['alerttype'])){
-			$sql_parts['where'][] = 'a.alerttype='.$options['alerttype'];
+			$sql_parts['where'][] = 'a.alerttype='.zbx_dbstr($options['alerttype']);
 		}
 
 // time_from
 		if(!is_null($options['time_from'])){
-			$sql_parts['where'][] = 'a.clock>'.$options['time_from'];
+			$sql_parts['where'][] = 'a.clock>'.zbx_dbstr($options['time_from']);
 		}
 
 // time_till
 		if(!is_null($options['time_till'])){
-			$sql_parts['where'][] = 'a.clock<'.$options['time_till'];
+			$sql_parts['where'][] = 'a.clock<'.zbx_dbstr($options['time_till']);
 		}
 
 // extendoutput
@@ -514,10 +514,10 @@
 			$alertid = get_dbid('alerts', 'alertid');
 			$sql = 'INSERT INTO alerts '.
 					'(alertid, actionid, eventid, userid, mediatypeid, clock, sendto, subject, message, status, retries, error, nextcheck, esc_step, alerttype) '.
-					' VALUES ('.$alertid.','.$alert['actionid'].','.$alert['eventid'].','.$alert['userid'].','.$alert['mediatypeid'].','.
-								$alert['clock'].','.zbx_dbstr($alert['sendto']).','.zbx_dbstr($alert['subject']).','.zbx_dbstr($alert['message']).','.
-								$alert['status'].','.$alert['retries'].','.zbx_dbstr($alert['error']).','.$alert['nextcheck'].','.
-								$alert['esc_step'].','.$alert['alerttype'].' )';
+					' VALUES ('.$alertid.','.zbx_dbstr($alert['actionid']).','.zbx_dbstr($alert['eventid']).','.zbx_dbstr($alert['userid']).','.zbx_dbstr($alert['mediatypeid']).','.
+								zbx_dbstr($alert['clock']).','.zbx_dbstr($alert['sendto']).','.zbx_dbstr($alert['subject']).','.zbx_dbstr($alert['message']).','.
+								zbx_dbstr($alert['status']).','.zbx_dbstr($alert['retries']).','.zbx_dbstr($alert['error']).','.zbx_dbstr($alert['nextcheck']).','.
+								zbx_dbstr($alert['esc_step']).','.zbx_dbstr($alert['alerttype']).' )';
 			$result = DBexecute($sql);
 			if(!$result) break;
 
Index: frontends/php/include/regexp.inc.php
===================================================================
--- frontends/php/include/regexp.inc.php	(revision 38884)
+++ frontends/php/include/regexp.inc.php	(working copy)
@@ -23,7 +23,7 @@
 	$sql = 'SELECT re.* '.
 					' FROM regexps re '.
 					' WHERE '.DBin_node('re.regexpid').
-						' AND regexpid='.$regexpid;
+						' AND regexpid='.zbx_dbstr($regexpid);
 
 	$db_regexp = DBfetch(DBselect($sql));
 return $db_regexp;
@@ -80,7 +80,7 @@
 	$sql = 'UPDATE regexps SET '.
 				' name='.zbx_dbstr($regexp['name']).','.
 				' test_string='.zbx_dbstr($regexp['test_string']).
-			' WHERE regexpid='.$regexpid;
+			' WHERE regexpid='.zbx_dbstr($regexpid);
 	$result = DBexecute($sql);
 return $result;
 }
@@ -117,8 +117,8 @@
 				' VALUES ('.$expressionid.','.
 						$regexpid.','.
 						zbx_dbstr($expression['expression']).','.
-						$expression['expression_type'].','.
-						$expression['case_sensitive'].','.
+						zbx_dbstr($expression['expression_type']).','.
+						zbx_dbstr($expression['case_sensitive']).','.
 						zbx_dbstr($expression['exp_delimiter']).')');
 
 return $result?$expressionid:false;
Index: frontends/php/include/reports.inc.php
===================================================================
--- frontends/php/include/reports.inc.php	(revision 38884)
+++ frontends/php/include/reports.inc.php	(working copy)
@@ -64,10 +64,10 @@
 		$cmbHGrps->addItem(0,S_ALL_SMALL);
 
 		$sql_cond = ' AND h.hostid=ht.hostid ';
-		if($_REQUEST['hostid'] > 0)	$sql_cond.=' AND ht.templateid='.$_REQUEST['hostid'];
+		if($_REQUEST['hostid'] > 0)	$sql_cond.=' AND ht.templateid='.zbx_dbstr($_REQUEST['hostid']);
 
 		if(isset($_REQUEST['tpl_triggerid']) && ($_REQUEST['tpl_triggerid'] > 0))
-			$sql_cond.= ' AND t.templateid='.$_REQUEST['tpl_triggerid'];
+			$sql_cond.= ' AND t.templateid='.zbx_dbstr($_REQUEST['tpl_triggerid']);
 
 		$result = DBselect('SELECT DISTINCT g.groupid,g.name '.
 			' FROM triggers t,hosts h,items i,functions f, hosts_templates ht, groups g, hosts_groups hg '.
@@ -91,7 +91,7 @@
 				);
 		}
 
-		$sql_cond=($_REQUEST['hostid'] > 0)?' AND h.hostid='.$_REQUEST['hostid']:' AND '.DBcondition('h.hostid',$available_hosts);
+		$sql_cond=($_REQUEST['hostid'] > 0)?' AND h.hostid='.zbx_dbstr($_REQUEST['hostid']):' AND '.DBcondition('h.hostid',$available_hosts);
 		$sql = 'SELECT DISTINCT t.triggerid,t.description '.
 			' FROM triggers t,hosts h,items i,functions f '.
 			' WHERE f.itemid=i.itemid '.
Index: frontends/php/include/classes/class.cchart.php
===================================================================
--- frontends/php/include/classes/class.cchart.php	(revision 38884)
+++ frontends/php/include/classes/class.cchart.php	(working copy)
@@ -247,9 +247,9 @@
 						' count(*) as count,avg(value) as avg,min(value) as min,'.
 						' max(value) as max,max(clock) as clock'.
 					' FROM history '.
-					' WHERE itemid='.$this->items[$i]['itemid'].
-						' AND clock>='.$from_time.
-						' AND clock<='.$to_time.
+					' WHERE itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND clock>='.zbx_dbstr($from_time).
+						' AND clock<='.zbx_dbstr($to_time).
 					' GROUP BY itemid,'.$calc_field
 					,
 
@@ -257,9 +257,9 @@
 						' count(*) as count,avg(value) as avg,min(value) as min,'.
 						' max(value) as max,max(clock) as clock'.
 					' FROM history_uint '.
-					' WHERE itemid='.$this->items[$i]['itemid'].
-						' AND clock>='.$from_time.
-						' AND clock<='.$to_time.
+					' WHERE itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND clock>='.zbx_dbstr($from_time).
+						' AND clock<='.zbx_dbstr($to_time).
 					' GROUP BY itemid,'.$calc_field
 					);
 			}
@@ -270,9 +270,9 @@
 						' sum(num) as count,avg(value_avg) as avg,min(value_min) as min,'.
 						' max(value_max) as max,max(clock) as clock'.
 					' FROM trends '.
-					' WHERE itemid='.$this->items[$i]['itemid'].
-						' AND clock>='.$from_time.
-						' AND clock<='.$to_time.
+					' WHERE itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND clock>='.zbx_dbstr($from_time).
+						' AND clock<='.zbx_dbstr($to_time).
 					' GROUP BY itemid,'.$calc_field
 					,
 
@@ -280,9 +280,9 @@
 						' sum(num) as count,avg(value_avg) as avg,min(value_min) as min,'.
 						' max(value_max) as max,max(clock) as clock'.
 					' FROM trends_uint '.
-					' WHERE itemid='.$this->items[$i]['itemid'].
-						' AND clock>='.$from_time.
-						' AND clock<='.$to_time.
+					' WHERE itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND clock>='.zbx_dbstr($from_time).
+						' AND clock<='.zbx_dbstr($to_time).
 					' GROUP BY itemid,'.$calc_field
 					);
 
@@ -451,11 +451,11 @@
 						" AND f.function IN ('last','min','avg','max') ".
 						' AND tr.status='.TRIGGER_STATUS_ENABLED.
 						' AND i.itemid=f.itemid '.
-						' AND f.itemid='.$item['itemid'].
+						' AND f.itemid='.zbx_dbstr($item['itemid']).
 					' ORDER BY tr.priority';
 			$db_triggers = DBselect($sql);
 			while(($trigger = DBfetch($db_triggers)) && ($cnt < $max)){
-				$db_fnc_cnt = DBselect('SELECT count(*) as cnt FROM functions f WHERE f.triggerid='.$trigger['triggerid']);
+				$db_fnc_cnt = DBselect('SELECT count(*) as cnt FROM functions f WHERE f.triggerid='.zbx_dbstr($trigger['triggerid']));
 				$fnc_cnt = DBfetch($db_fnc_cnt);
 
 				if($fnc_cnt['cnt'] != 1) continue;
Index: frontends/php/include/classes/class.cpie.php
===================================================================
--- frontends/php/include/classes/class.cpie.php	(revision 38884)
+++ frontends/php/include/classes/class.cpie.php	(working copy)
@@ -190,9 +190,9 @@
 						' max(h.value) AS max,max(h.clock) AS clock, max(i.lastvalue) as lst '.
 					' FROM history h '.
 						' LEFT JOIN items i ON h.itemid = i.itemid'.
-					' WHERE h.itemid='.$this->items[$i]['itemid'].
-						' AND h.clock>='.$from_time.
-						' AND h.clock<='.$to_time.
+					' WHERE h.itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND h.clock>='.zbx_dbstr($from_time).
+						' AND h.clock<='.zbx_dbstr($to_time).
 					' GROUP BY h.itemid'
 					,
 
@@ -201,9 +201,9 @@
 						' max(hu.value) AS max,max(hu.clock) AS clock, max(i.lastvalue) as lst'.
 					' FROM history_uint hu '.
 						' LEFT JOIN items i ON hu.itemid = i.itemid'.
-					' WHERE hu.itemid='.$this->items[$i]['itemid'].
-						' AND hu.clock>='.$from_time.
-						' AND hu.clock<='.$to_time.
+					' WHERE hu.itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND hu.clock>='.zbx_dbstr($from_time).
+						' AND hu.clock<='.zbx_dbstr($to_time).
 					' GROUP BY hu.itemid'
 					);
 			}
@@ -215,9 +215,9 @@
 						' max(t.value_max) AS max,max(t.clock) AS clock, max(i.lastvalue) as lst'.
 					' FROM trends t '.
 						' LEFT JOIN items i ON t.itemid = i.itemid'.
-					' WHERE t.itemid='.$this->items[$i]['itemid'].
-						' AND t.clock>='.$from_time.
-						' AND t.clock<='.$to_time.
+					' WHERE t.itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND t.clock>='.zbx_dbstr($from_time).
+						' AND t.clock<='.zbx_dbstr($to_time).
 					' GROUP BY t.itemid'
 					,
 
@@ -226,9 +226,9 @@
 						' max(t.value_max) AS max,max(t.clock) AS clock, max(i.lastvalue) as lst'.
 					' FROM trends_uint t '.
 						' LEFT JOIN items i ON t.itemid = i.itemid'.
-					' WHERE t.itemid='.$this->items[$i]['itemid'].
-						' AND t.clock>='.$from_time.
-						' AND t.clock<='.$to_time.
+					' WHERE t.itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND t.clock>='.zbx_dbstr($from_time).
+						' AND t.clock<='.zbx_dbstr($to_time).
 					' GROUP BY t.itemid'
 					);
 			}
